/* cdb_hash.c
** wcm, 2010.06.11 - 2010.10.27
** ===
*/

#include <stddef.h>
#include <stdint.h>

#include "uchar.h"

#include "cdb.h"

#if 0
uint32_t
cdb_hash(const uchar_t *key, size_t klen)
{
  uint32_t   h = CDB_HASHINIT;

  while(klen){
      /* mix operation (precedes combine): */
      h += CDB_HASHMIX(h);
      /* combine: */
      h ^= *key;
      ++key; --klen;
  }

  return h;
}
#endif

uint32_t
cdb_hash(const uchar_t *key, size_t klen)
{
  uint32_t   h = CDB_HASHINIT;

  while(klen > 3){
      /* mix operation precedes combine: */
      h += CDB_HASHMIX(h); h ^= *key++;
      h += CDB_HASHMIX(h); h ^= *key++;
      h += CDB_HASHMIX(h); h ^= *key++;
      h += CDB_HASHMIX(h); h ^= *key++;
      klen -= 4;
  }

  switch(klen){
  case 3: h+= CDB_HASHMIX(h); h ^= *key++; /* fallthrough */
  case 2: h+= CDB_HASHMIX(h); h ^= *key++; /* fallthrough */
  case 1: h+= CDB_HASHMIX(h); h ^= *key++;
  }

  return h;
}

/* eof (cdb_hash.c) */
