/* cdb_hashnext.c
** incremental version of cdb_hash() function for cdbmake
** wcm, 2010.06.11 - 2010.10.26
** ===
*/

#include <stddef.h>
#include <stdint.h>

#include "uchar.h"

#include "cdb.h"

/* cdb_hashnext()
**   incremental cdb_hash() support for cdbmake
**
**   usage:
**
**       h = CDB_HASHINIT;
**       while(klen){
**           h = cdb_hashnext(h, *key);
**           ++key; --klen;
**       }
*/


uint32_t
cdb_hashnext(uint32_t h, uchar_t c)
{
  /* mix: */
  h += CDB_HASHMIX(h);
  /* combine/return: */
  return h ^ c;
}

/* eof (cdb_hashnext.c) */
